import * as ts from "typescript";
export declare enum AnnotationKind {
    CustomConstructor = "customConstructor",
    CompileMembersOnly = "compileMembersOnly",
    NoResolution = "noResolution",
    NoSelf = "noSelf",
    CustomName = "customName",
    NoSelfInFile = "noSelfInFile"
}
export interface Annotation {
    kind: AnnotationKind;
    args: string[];
}
export type AnnotationsMap = Map<AnnotationKind, Annotation>;
export declare function getSymbolAnnotations(symbol: ts.Symbol): AnnotationsMap;
export declare function getTypeAnnotations(type: ts.Type): AnnotationsMap;
export declare function getNodeAnnotations(node: ts.Node): AnnotationsMap;
export declare function getFileAnnotations(sourceFile: ts.SourceFile): AnnotationsMap;
