import * as ts from "typescript";
import * as lua from "../../LuaAST";
import { LuaTarget, TypeScriptToLuaOptions } from "../../CompilerOptions";
import { AnnotationKind } from "./annotations";
export declare const unsupportedNodeKind: ((node: ts.Node, kind: ts.SyntaxKind) => ts.Diagnostic) & {
    code: number;
};
export declare const forbiddenForIn: ((node: ts.Node, ...args: any[]) => ts.Diagnostic) & {
    code: number;
};
export declare const unsupportedNoSelfFunctionConversion: ((node: ts.Node, name?: string | undefined) => ts.Diagnostic) & {
    code: number;
};
export declare const unsupportedSelfFunctionConversion: ((node: ts.Node, name?: string | undefined) => ts.Diagnostic) & {
    code: number;
};
export declare const unsupportedOverloadAssignment: ((node: ts.Node, name?: string | undefined) => ts.Diagnostic) & {
    code: number;
};
export declare const decoratorInvalidContext: ((node: ts.Node, ...args: any[]) => ts.Diagnostic) & {
    code: number;
};
export declare const annotationInvalidArgumentCount: ((node: ts.Node, kind: AnnotationKind, got: number, expected: number) => ts.Diagnostic) & {
    code: number;
};
export declare const invalidRangeUse: ((node: ts.Node, ...args: any[]) => ts.Diagnostic) & {
    code: number;
};
export declare const invalidVarargUse: ((node: ts.Node, ...args: any[]) => ts.Diagnostic) & {
    code: number;
};
export declare const invalidRangeControlVariable: ((node: ts.Node, ...args: any[]) => ts.Diagnostic) & {
    code: number;
};
export declare const invalidMultiIterableWithoutDestructuring: ((node: ts.Node, ...args: any[]) => ts.Diagnostic) & {
    code: number;
};
export declare const invalidPairsIterableWithoutDestructuring: ((node: ts.Node, ...args: any[]) => ts.Diagnostic) & {
    code: number;
};
export declare const unsupportedAccessorInObjectLiteral: ((node: ts.Node, ...args: any[]) => ts.Diagnostic) & {
    code: number;
};
export declare const unsupportedRightShiftOperator: ((node: ts.Node, ...args: any[]) => ts.Diagnostic) & {
    code: number;
};
export declare const unsupportedForTarget: ((node: ts.Node, functionality: string, version: LuaTarget) => ts.Diagnostic) & {
    code: number;
};
export declare const unsupportedForTargetButOverrideAvailable: ((node: ts.Node, functionality: string, version: LuaTarget, optionName: keyof TypeScriptToLuaOptions) => ts.Diagnostic) & {
    code: number;
};
export declare const unsupportedProperty: ((node: ts.Node, parentName: string, property: string) => ts.Diagnostic) & {
    code: number;
};
export declare const invalidAmbientIdentifierName: ((node: ts.Node, text: string) => ts.Diagnostic) & {
    code: number;
};
export declare const unsupportedVarDeclaration: ((node: ts.Node, ...args: any[]) => ts.Diagnostic) & {
    code: number;
};
export declare const invalidMultiFunctionUse: ((node: ts.Node, ...args: any[]) => ts.Diagnostic) & {
    code: number;
};
export declare const invalidMultiFunctionReturnType: ((node: ts.Node, ...args: any[]) => ts.Diagnostic) & {
    code: number;
};
export declare const invalidMultiReturnAccess: ((node: ts.Node, ...args: any[]) => ts.Diagnostic) & {
    code: number;
};
export declare const invalidCallExtensionUse: ((node: ts.Node, ...args: any[]) => ts.Diagnostic) & {
    code: number;
};
export declare const annotationDeprecated: ((node: ts.Node, kind: AnnotationKind) => ts.Diagnostic) & {
    code: number;
};
export declare const truthyOnlyConditionalValue: ((node: ts.Node, ...args: any[]) => ts.Diagnostic) & {
    code: number;
};
export declare const notAllowedOptionalAssignment: ((node: ts.Node, ...args: any[]) => ts.Diagnostic) & {
    code: number;
};
export declare const awaitMustBeInAsyncFunction: ((node: ts.Node, ...args: any[]) => ts.Diagnostic) & {
    code: number;
};
export declare const unsupportedBuiltinOptionalCall: ((node: ts.Node, ...args: any[]) => ts.Diagnostic) & {
    code: number;
};
export declare const unsupportedOptionalCompileMembersOnly: ((node: ts.Node, ...args: any[]) => ts.Diagnostic) & {
    code: number;
};
export declare const undefinedInArrayLiteral: ((node: ts.Node, ...args: any[]) => ts.Diagnostic) & {
    code: number;
};
export declare const invalidMethodCallExtensionUse: ((node: ts.Node, ...args: any[]) => ts.Diagnostic) & {
    code: number;
};
export declare const invalidSpreadInCallExtension: ((node: ts.Node, ...args: any[]) => ts.Diagnostic) & {
    code: number;
};
export declare const cannotAssignToNodeOfKind: ((node: ts.Node, kind: lua.SyntaxKind) => ts.Diagnostic) & {
    code: number;
};
export declare const incompleteFieldDecoratorWarning: ((node: ts.Node, ...args: any[]) => ts.Diagnostic) & {
    code: number;
};
