"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.transformLuaLibFunction = exports.importLuaLibFeature = exports.LuaLibFeature = void 0;
const lua = require("../../LuaAST");
const LuaLib_1 = require("../../LuaLib");
Object.defineProperty(exports, "LuaLibFeature", { enumerable: true, get: function () { return LuaLib_1.LuaLibFeature; } });
function importLuaLibFeature(context, feature) {
    context.usedLuaLibFeatures.add(feature);
}
exports.importLuaLibFeature = importLuaLibFeature;
function transformLuaLibFunction(context, feature, tsParent, ...params) {
    importLuaLibFeature(context, feature);
    const functionIdentifier = lua.createIdentifier(`__TS__${feature}`);
    return lua.createCallExpression(functionIdentifier, params, tsParent);
}
exports.transformLuaLibFunction = transformLuaLibFunction;
//# sourceMappingURL=lualib.js.map